/* 
 * CSE142, 98 Autumn
 * Homework 4
 * Rain Gods and Goddesses

  STARTER PROGRAM

  To start with, your job is to figure out what this program does.
 * Name:           Peter Jantz
 * Student ID:     9823093
 * Quiz Section:   BB

/* There's a landscape in the background...

*/

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	7

/*color of letter on buttons*/
#define SELECTED_COLOR   YELLOW	 
#define UNSELECTED_COLOW PURPLE

#define MAX_PRECIP_EVENTS	500
	/*This is the total number of drops possible at one time.*/

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define LIGHTNING 3

/*if you add new types of percip, you may need to change this*/
#define MAX_PRECIP_TYPES 3

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button (doesn't say which one yet)*/
#define DIRT 2
	/*The above means you clicked in the dirt area */

/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally*/

void  ClearAllPrecipitation(int *precip_type, int *precip_color, int *xcoord, int *ycoord);

/*render (draw) all the precipitation*/
void DrawAllPrecipitation(int type, int bottom_x, int bottom_y, int color);


void DrawLandscape(int sun_x, int sun_y, int moon_x, int moon_y,
				   int cloud1_x, int cloud1_y, int *Day);

void DrawTree(int a, int b);   /* Draws one Tree */
void DrawNight();
void DrawForest();   /* Draws Forest around cabin */
void DrawCloud1(int x, int y);
void DrawEvening();

void Dog(int dog_x, int dog_y);
void Spaceship(int x, int y); /* Draws UFO */

void DrawStar(int x, int y, int size); /* used to draw one star */
/*draw one drop*/
void DrawPrecipColumn(int precip_type, int bottom_x, int bottom_y, int color);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);
void DrawLightning (int x, int y, int color);

void StartFire(int x, int y, int color1, int color2, int color3, int w, int h);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant);






/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/
int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y;
  char key_hit;

  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 45;
  int moon_x =-GP142_XMAX + 50, moon_y = GP142_YMAX - 35;
  int Day = TRUE;
  
  int cloud1_x = 0;
  int cloud1_y = GP142_YMAX - 45;

  int i, count, n;

  int j = 0;
  int color1 = YELLOW;
  int color2 = ORANGE;
  int color3 = RED;
  int c1, c2, c3;
  int num_fires = 0;

  int dog_x = 0;
  int dog_y = TOP_OF_DIRT - 50;

  int ship_x = -150;
  int ship_y = GP142_YMAX;

  int abtime = 0;

  
  
  
  /* 
   * The next itens tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  
  int precip_type[MAX_PRECIP_EVENTS];
  int precip_color[MAX_PRECIP_EVENTS];

  int xfirept[MAX_PRECIP_EVENTS];   /* gives the point used for each fire */
  int yfirept[MAX_PRECIP_EVENTS];

  int width[200];       /* stores the width and height for each fire */
  int height[200];

  int xcoord[MAX_PRECIP_EVENTS]; /* coordinates for the precipitation */
  int ycoord[MAX_PRECIP_EVENTS];
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;

  /*what kind of click was there?*/
  int mouse_click;

  int event;  /*the most recent GP142 event*/

  int k;

  time_t t; /*needed only when initializing a random number generator*/

  count = 0;

  for (k = 0; k < 200; k++){

      width[k] = 4;        /* sets initial dimensions for every fire */
      height[k] = 10;
  }

   

  /*
   * INITIALIZATIONS
   */

      
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.
		*/

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  DrawLandscape(sun_x, sun_y, moon_x, moon_y, cloud1_x, cloud1_y, &Day);
  Dog(dog_x, dog_y);
  
  DrawButtons(current_precip, current_color);	  /* Show the buttons...*/ 
  
  /* initially clears all precipitation */
  i = 0;
  while (i < count){

	  xcoord[i] = NONE;
	  ycoord[i] = NONE;
	  precip_color[i] = NONE ;
	  precip_type[i] = NONE;
	  

	  i = i + 1;
  }
  count = 0;
			

  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag);

		
		/* clears all precipitation  */
         
		if (clear_flag == TRUE){
					
			i = 0;
			while (i < count){

				xcoord[i] = NONE;
				ycoord[i] = NONE;
				precip_color[i] = NONE;
				precip_type[i] = NONE;
               
			
				i = i + 1;
			}
			count = 0;

            for (k = 0; k < 200; k++){

                width[k] = 4;
                height[k] = 10;
            }

            num_fires = 0;
			j = 0;
		}
			
			       


		
	
			
		
		 
	}
	else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE))
			
	{
         /* sets precip type, color, x coordinate, and y coordinate to the
		 current settings */
		
        precip_type[count] = current_precip;
		precip_color[count] = current_color;
                                               /* stores the coordinates, type, and
											color for each prcipitation drop */
		xcoord[count] = mouse_x;
		ycoord[count] = mouse_y;

		/* Draws all precipitation */

		i = 0;
		
		while (i < count)
		{
			DrawAllPrecipitation(precip_type[i], xcoord[i], ycoord[i], precip_color[i]);

			i = i + 1;
		}

		count = count + 1;
	    /* number of precipitaion drops */
	}
      
      break;


    case GP142_PERIODIC:
      	/*Some time has passed, 
		so make all the precipitation a little lower*/

        i = 0;
		
		while (i < count)
		{
			
			if (precip_type[i] == SNOW)
			{
				ycoord[i] = ycoord[i] - 2;
			}

            else if (precip_type[i] == RAIN)

			{									
                ycoord[i] = ycoord[i] - 6;
			}

			

			else {}

			if (precip_type[i] != LIGHTNING)
			{
				if (ycoord[i] < (TOP_OF_DIRT - 50))
				{
					ycoord[i] = GP142_YMAX;
				}
				else{}
			}
						            
			i = i + 1;
		}


        c1 = color1;  
		c2 = color2;
		c3 = color3;   /* changes color of each flame in fire */

        color1 = c3;
        color2 = c1;
		color3 = c2;




        for (k = 0; k < num_fires; k++){

            if (width[k] < 30)
            {
                width[k] = width[k] + 2;     /* The width and height of each flame */
                height[k] = height[k] + 3;   /* increase until the width is 30. */
            }
        }

		
		/* moves the cloud across the screen */

		if (cloud1_x >= (GP142_XMAX + 50)){

			cloud1_x = -cloud1_x;
		}

		else {}

		cloud1_x++;

		
		/* Once abtime is greater than 0 the abduction begins */

		if (abtime > 0){

			if (abtime == 20){       /* Moves the spaceship away after the */  
                                     /* abduction is complete */ 
				ship_x = ship_x + 5;
			    ship_y = ship_y + 10;
			}

			if (ship_x < -50){       /* Moves the spaceship into position */

				ship_x = ship_x + 20;
			    ship_y = ship_y - 10;
			}

			else if (ship_x == -50){      /* The spaceship stops and abducts the poor dog */

				
			    dog_y = dog_y + 20;
			}

			else if (ship_x > -50){     /* sends the spaceship back into outer space */

				ship_x = ship_x + 5;
			    ship_y = ship_y + 10;
			}
		}

		

		

		

		/*** what goes here to make a raindrop fall?*/

		/*and change the sun's position a little bit*/
		if (sun_x <= -GP142_XMAX - 30){

			Day = FALSE;            /* changes Day to Night if the suns coordinates */ 
	        sun_x = -sun_x;         /* off the screen.  */
			sun_y = GP142_YMAX -45;
		}

	    else if (moon_x >= GP142_XMAX + 30){

			Day = TRUE;
	        moon_x = -moon_x;
		}

		else{}

		if (Day == TRUE) {
			
			sun_x = sun_x - 5;
				/* over a long period of time, the sun will set.*/
			if (sun_x >= 100){

				sun_y++;
			}

			else if (sun_x <= -100)
			{
				sun_y--;
			}
		

		}
		else {
			moon_x = moon_x + 5;
		}

      break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
    


    DrawLandscape(sun_x, sun_y, moon_x, moon_y, cloud1_x, cloud1_y, &Day);


	/* Draws the ill fated Hound and the spaceship. */

	if (abtime < 20){

		Dog(dog_x, dog_y);
	}

	/* One fire must start to enable the abduction to start */

	if ((num_fires > 0) && (abtime <= 40)){
		
		Spaceship(ship_x, ship_y);

		if ((abtime > 3) && (abtime < 20)){

			GP142_lineXY(RED, dog_x + 10, ship_y - 35, dog_x + 10, dog_y, 5);
		}

		if (abtime > 20){

			GP142_printfXY(RED, 0, (GP142_YMAX - 50), 15, "THE TRUTH IS OUT THERE");
		}

		abtime++;
		
	}


    DrawButtons(current_precip, current_color);
    
	/* Precipitation Loop */
    i = 0;
	
		while (i < count)
		{
			if (precip_type[i] == LIGHTNING)  
			{                                 

				DrawAllPrecipitation(precip_type[i], xcoord[i],
					ycoord[i], precip_color[i]);


				xfirept[j] = xcoord[i];
				yfirept[j] = ycoord[i] - 200;
			
                      
			
				xcoord[i] = NONE;         /* Lightning does not reappear on the screen */
				ycoord[i] = NONE;         /* like the other precipitation types */
				precip_color[i] = NONE;
				precip_type[i] = NONE;

                num_fires = num_fires + 1;
                j = j + 1;
				
			}

			else {

				DrawAllPrecipitation(precip_type[i], xcoord[i],
					ycoord[i], precip_color[i]);
                
			}


			/* Starts a fire only if Lightning stikes in the forest or on the cabin */

            for (n = 0; n < num_fires; n++)
            {
                if ((yfirept[n] < (TOP_OF_DIRT + 95)) && (yfirept[n] > (TOP_OF_DIRT + 40))){

                    
					StartFire(xfirept[n], yfirept[n], color1, color2, color3, width[n], height[n]);
				}
				else if ((yfirept[n] < (TOP_OF_DIRT + 40)) && (yfirept[n] > (TOP_OF_DIRT - 60))
					&& (xfirept[n] < -40))
				{
					StartFire(xfirept[n], yfirept[n], color1, color2, color3, width[n], height[n]);
				}

				else if ((yfirept[n] < (TOP_OF_DIRT + 40)) && (yfirept[n] > (TOP_OF_DIRT - 60))
					&& (xfirept[n] > 40)){
					StartFire(xfirept[n], yfirept[n], color1, color2, color3, width[n], height[n]);
				}

				else if ((yfirept[n] < (TOP_OF_DIRT + 30)) && (yfirept[n] > (TOP_OF_DIRT - 20))
					&& (xfirept[n] > -20) && (xfirept[n] < 20)){
					StartFire(0, TOP_OF_DIRT + 20, color1, color2, color3, width[n], height[n]);
				}
                else {}
            }

			i = i + 1;
		}

		
	

  }  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */





/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased. Not used currently
	*/
void  ClearAllPrecipitation(int *precip_type, int *precip_color, int *xcoord, int *ycoord)
{
  
  *precip_type = NONE;
  *precip_color = NONE;
  *xcoord = NONE;
  *ycoord = NONE;

  
  
  

}




#define RAINDROP_WIDTH 3

void DrawRainDrop (int x, int y, int color) { 

	GP142_circleXY(color, x, y, RAINDROP_WIDTH);
	

}



#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

void DrawSnowDrop (int x, int y, int color) {

	GP142_triangleXY(color, x, y, x, y + SNOWDROP_HEIGHT, x + SNOWDROP_WIDTH, y, 0); 
}




void DrawLightning (int x, int y, int color){

	int y_bottom, ypt;

    ypt = y;
    
	y_bottom = y - 200;


	
	while (ypt > y_bottom){
		GP142_lineXY(color, x, ypt, x - 30, ypt - 50, 2);
	    GP142_lineXY(color, x -30, ypt - 50, x, ypt - 100, 2);

		ypt = ypt - 100;
	}

}


void StartFire(int x, int y, int color1, int color2, int color3, int w, int h){

	GP142_triangleXY(color1, (x - (w / 2)), y, (x + (w / 2)), y, x, y + h, 0);
	GP142_triangleXY(color2, (x - w), y, (x - (w / 8)), y,
        (x - (w * 5 / 8)), y + (h - 2), 0);
	GP142_triangleXY(color2, (x + w), y, (x + (w / 8)), y, 
        (x + (w * 5 / 8)), y + (h - 2), 0);

    if (w > 20)
    {

        GP142_triangleXY(color1, (x - (3 * w / 2)), y, (x  - (w / 2)), y,
			(x - w), y + (h / 2), 0);
        GP142_triangleXY(color1, (x + (w / 2)), y, (x + (3 * w / 2)), y,
			(x + w), y + (h / 2), 0);
		GP142_triangleXY(color3, (x - (w / 2)), y, (x + (w / 2)), y,
			x, y + (h / 2), 0);
	}
		

}

void DrawCloud1(int x, int y){

	GP142_circleXY(MED_GRAY, x, y, 23);
	GP142_circleXY(MED_GRAY, x - 30, y, 20);
	GP142_circleXY(MED_GRAY, x + 30, y + 10, 15);
	GP142_circleXY(MED_GRAY, x + 20, y - 18, 15);

}



void Dog(int dog_x, int dog_y){

	GP142_lineXY(BLACK, dog_x, dog_y, dog_x + 6, dog_y + 2, 1);
	GP142_lineXY(BLACK, dog_x, dog_y, dog_x + 6, dog_y - 2, 2);
	GP142_lineXY(BLACK, dog_x + 6, dog_y - 2, dog_x + 6, dog_y - 10, 1);
	GP142_lineXY(BLACK, dog_x + 6, dog_y - 10, dog_x + 10, dog_y - 10, 1);
	GP142_lineXY(BLACK, dog_x + 10, dog_y - 10, dog_x + 10, dog_y - 8, 1);
	GP142_lineXY(BLACK, dog_x + 10, dog_y - 8, dog_x + 8, dog_y - 8, 1);
	GP142_lineXY(BLACK, dog_x + 8, dog_y - 8, dog_x + 8, dog_y - 4, 1);
    GP142_lineXY(BLACK, dog_x + 8, dog_y - 4, dog_x + 16, dog_y - 4, 1);
    GP142_lineXY(BLACK, dog_x + 16, dog_y - 4, dog_x + 16, dog_y - 10, 1);
    GP142_lineXY(BLACK, dog_x + 16, dog_y - 10, dog_x + 20, dog_y - 10, 1);
    GP142_lineXY(BLACK, dog_x + 20, dog_y - 10, dog_x + 20, dog_y - 8, 1);
	GP142_lineXY(BLACK, dog_x + 20, dog_y - 8, dog_x + 18, dog_y - 8, 1);
	GP142_lineXY(BLACK, dog_x + 18, dog_y - 8, dog_x + 18, dog_y - 2, 1);
	GP142_lineXY(BLACK, dog_x + 18, dog_y - 2, dog_x + 23, dog_y - 2, 1);
	GP142_lineXY(BLACK, dog_x + 23, dog_y - 2, dog_x + 23, dog_y + 2, 1);
	GP142_lineXY(BLACK, dog_x + 6, dog_y + 2, dog_x + 16, dog_y + 2, 1);
	GP142_lineXY(BLACK, dog_x + 16, dog_y + 2, dog_x + 17, dog_y + 5, 1);
	GP142_lineXY(BLACK, dog_x + 17, dog_y + 5, dog_x + 19, dog_y + 5, 1);
	GP142_lineXY(BLACK, dog_x + 19, dog_y + 5, dog_x + 20, dog_y + 1, 1);
	GP142_lineXY(BLACK, dog_x + 20, dog_y + 1, dog_x + 23, dog_y + 1, 1);
	GP142_lineXY(BLACK, dog_x + 23, dog_y - 1, dog_x + 21, dog_y - 1, 1);
	GP142_pixelXY(BLACK, dog_x + 18, dog_y + 2);




}


void Spaceship(int x, int y){

	GP142_ovalXY(MAGENTA, x, y, x + 100, y - 40, 0);
	
	GP142_ovalXY(BLACK, x + 20, y - 40, x + 80, y - 32, 0);

	GP142_circleXY(GOLD, x + 15, y - 18, 4); 
	GP142_circleXY(GOLD, x + 50, y - 12, 4); 
    GP142_circleXY(GOLD, x + 85, y - 18, 4);
	

}








void DrawAllPrecipitation(int type, int bottom_x, int bottom_y, int color)
{
	
	

	if (bottom_y >= TOP_OF_DIRT - 20) {
		switch (type) {
		case RAIN:
			DrawRainDrop (bottom_x, bottom_y, color);
			break;
		case SNOW:
			DrawSnowDrop (bottom_x, bottom_y, color);
			break;
        case LIGHTNING:
			DrawLightning (bottom_x, bottom_y, color);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/

	}	
	
	

	
}





int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}





void DrawTree(int a, int b)
{
    GP142_rectangleXY(BROWN, a, b, a + 4, b + 12, 0);
    GP142_rectangleXY(BLACK, a, b, a + 4, b + 12, 1);

    GP142_triangleXY(GREEN, a - 6, b + 12, a + 10, b + 12,
        a + 2, b + 18, 0);
    

    GP142_triangleXY(GREEN, a - 5, b + 16, a + 9, b + 16,
        a + 2, b + 24, 0);

    GP142_triangleXY(GREEN, a - 4, b + 22, a + 8, b + 22,
        a + 2, b + 28, 0);

}



void DrawForest()
{
	int col, row;

	row = TOP_OF_DIRT + 70;
	
	while (row >= (TOP_OF_DIRT + 40))
	{
		col = -40;

		while (col < (GP142_XMAX - 10))
		{
			DrawTree(col, row);

			col = col + 15;
		}
		row = row - 20;
	}

	for (row = TOP_OF_DIRT + 20; row >= (TOP_OF_DIRT - 60); row = row - 20)
	{
		for (col = -250 + 20; col <= -40; col = col + 15)
		{
			DrawTree(col, row);
		}
	}
	
	for (row = TOP_OF_DIRT + 20; row >= (TOP_OF_DIRT - 60); row = row - 20)
	{
		for (col = 40; col <= (GP142_XMAX - 15); col = col + 15)
		{
			DrawTree(col, row);
		}
	}
}


void DrawNight(){

 GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);


	
}

void DrawEvening(){

	GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);

}

	
	
void DrawStar(int x, int y, int size)
{
    
        
     
    GP142_circleXY(WHITE, x, y, size);
    
	
}



	

void DrawLandscape(int sun_x, int sun_y, int moon_x, int moon_y,
				   int cloud1_x, int cloud1_y, int *Day)
{  

int text_offset = -GP142_XMAX + 15, font_size = 12;




if (*Day == TRUE){

	if ((sun_x < (GP142_XMAX / 2)) && (sun_x > (-GP142_XMAX / 2)))
	{
		 /* Draw the sky first */
		GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
	}
	else {

		DrawEvening();
	}


	
 
  /* Draw the sun */
  GP142_circleXY(YELLOW, sun_x, sun_y , 20);

  DrawCloud1(cloud1_x, cloud1_y);
  DrawCloud1(cloud1_x + 100, cloud1_y + 25);
}

else {
	DrawNight();

	DrawStar(0, GP142_YMAX -25, 3);
	DrawStar(-100,GP142_YMAX -28, 2);
    DrawStar(-150,GP142_YMAX -48, 3);
    DrawStar(-100,GP142_YMAX -53, 2);
    DrawStar(180, GP142_YMAX -39, 1);
    DrawStar(200,GP142_YMAX -30, 2);
    DrawStar(-200, GP142_YMAX -45, 3);
    DrawStar(-170, GP142_YMAX -22, 3);
    DrawStar(-240, GP142_YMAX -70, 4);
    DrawStar(59, GP142_YMAX -75, 3);
    DrawStar(107, GP142_YMAX -20, 1);

	
	GP142_circleXY(WHITE, moon_x, moon_y , 15);

	DrawCloud1(cloud1_x, cloud1_y);
	DrawCloud1(cloud1_x + 100, cloud1_y + 25);
}


  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");

  
  /*Draw the mountains */
  GP142_triangleXY(MED_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (GP142_YMAX - 100) ,
		   FILL);

  GP142_triangleXY(WHITE,
		   -60, TOP_OF_DIRT + 200,
		   60, TOP_OF_DIRT + 200,
		   0, (GP142_YMAX - 100) ,
		   FILL);


  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);



   /* Draws the cabin */

  GP142_rectangleXY(BROWN, -20, TOP_OF_DIRT - 20, 20,
      TOP_OF_DIRT + 20, FILL);

  GP142_lineXY(BLACK, -20, TOP_OF_DIRT - 20, 20, TOP_OF_DIRT - 20, 2);

  GP142_lineXY(BLACK, -20, TOP_OF_DIRT - 20, -20, TOP_OF_DIRT + 20, 2);

  GP142_lineXY(BLACK, 20, TOP_OF_DIRT - 20, 20, TOP_OF_DIRT + 20, 2);

  GP142_lineXY(BLACK, -20, TOP_OF_DIRT + 20, 20, TOP_OF_DIRT + 20, 2);

  GP142_rectangleXY(BLACK, -5, TOP_OF_DIRT - 20, 5, TOP_OF_DIRT + 2, 1);

  GP142_lineXY(BLACK, -20, TOP_OF_DIRT + 20, -10, TOP_OF_DIRT + 30, 2);

  GP142_lineXY(BLACK, 20, TOP_OF_DIRT + 20, 10, TOP_OF_DIRT + 30, 2);

  GP142_lineXY(BLACK, -10, TOP_OF_DIRT + 30, 10, TOP_OF_DIRT + 30, 2);

  GP142_triangleXY(BROWN, -20, TOP_OF_DIRT + 20, 0, TOP_OF_DIRT + 35,
      20, TOP_OF_DIRT + 20, FILL);

  GP142_triangleXY(BLACK, -20, TOP_OF_DIRT + 20, 0, TOP_OF_DIRT + 35,
      20, TOP_OF_DIRT + 20, 2);

  GP142_triangleXY(FOREST_GREEN, -10, TOP_OF_DIRT + 30, 0,
      TOP_OF_DIRT + 35, 10, TOP_OF_DIRT + 30, FILL);

  GP142_lineXY(BLACK, -10, TOP_OF_DIRT + 30, 10, TOP_OF_DIRT + 30, 2);

  GP142_circleXY(BLACK, 3, TOP_OF_DIRT - 8, 1);

  GP142_rectangleXY(BLUE, -18, TOP_OF_DIRT, -8, TOP_OF_DIRT + 10, 0);

  GP142_rectangleXY(BLACK, -18, TOP_OF_DIRT, -8, TOP_OF_DIRT + 10, 1);

  GP142_lineXY(BLACK, -13, TOP_OF_DIRT, -13, TOP_OF_DIRT + 10, 1);

  GP142_lineXY(BLACK, -18, TOP_OF_DIRT + 5, -8, TOP_OF_DIRT + 5, 1);

  /* Draws Forest around cabin */
  DrawForest();

} /*end DrawLandscape */





/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;

  case 2:
    *current_precip = LIGHTNING;
    break;
  
  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  case 5:
	*current_color = YELLOW;
	break;
  case 6:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}




/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(PURPLE,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(PURPLE, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(PURPLE, text_offset, i, font_size, "Snow");

  i -= BUTTON_HEIGHT;
  if (current_precip == LIGHTNING)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Lightning");
  else
    GP142_printfXY(PURPLE, text_offset, i, font_size, "Lightning");
  
 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(PURPLE, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(PURPLE, text_offset, i, font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color == YELLOW)
      GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Yellow");
  else
    GP142_printfXY(PURPLE, text_offset, i, font_size, "Yellow");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

}



void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}